;
; Builds AutoIt3 help file
;

#Region Includes
#include "include\OutputLib.au3"
#include "include\SettingsLib.au3"
#EndRegion Includes

#Region Global Variables
; The name of the project.
Global Const $g_sProjectLang = "english"
Global Const $g_sProject = "AutoIt Example Help"
Global Const $g_sProjectDir = "docs\autoit"
#EndRegion Global Variables

#Region Main body of code
Global $g_nExitCode = _Main()
Exit $g_nExitCode
#EndRegion Main body of code

#Region _Main()
; ===================================================================
; _Main()
;
; The main function responsible for generating the syntax files.
; Parameters:
;	None
; Returns:
;	0 on success, non-zero on failure.
; ===================================================================
Func _Main()
	; Create the output window and initial message.
	_OutputWindowCreate()
	_OutputProgressWrite("==== Output for " & StringTrimRight(@ScriptName, StringLen(".exe")) & " (" & $g_sProject & ") ====" & @CRLF)
	_OutputProgressWrite("Copying " & $g_sProject & " files." & @CRLF)

	; Set the build directory based on the rules and the INI file value.
	Local $sBuildDir = _SettingBuildDir()

	; Helpfile examples too
	Local Const $DIR_RECURSIVE = 1
	DirRemove($sBuildDir & "\install\Examples\Helpfile", $DIR_RECURSIVE)
	DirCreate($sBuildDir & "\install\Examples\Helpfile")
	FileCopy($sBuildDir & "\" & $g_sProjectDir & "\" & $g_sProjectLang & "\txt2htm\examples\*.au3", $sBuildDir & "\install\Examples\Helpfile\*.au3")
	FileCopy($sBuildDir & "\" & $g_sProjectDir & "\" & $g_sProjectLang & "\txt2htm\libExamples\*.au3", $sBuildDir & "\install\Examples\Helpfile\*.au3")
	FileCopy($sBuildDir & "\" & $g_sProjectDir & "\" & $g_sProjectLang & "\txt2htm\libExamples\Test.*", $sBuildDir & "\install\Examples\Helpfile\")
	DirCreate($sBuildDir & "\install\Examples\Helpfile\Extras")
	FileCopy($sBuildDir & "\" & $g_sProjectDir & "\" & $g_sProjectLang & "\txt2htm\libExamples\Extras\*.*", $sBuildDir & "\install\Examples\Helpfile\Extras\")

	; Write closing message and wait for close (if applicable).
	_OutputProgressWrite("Finished." & @CRLF & @CRLF) ; Two CRLF"s in case of chained output.
	_OutputWaitClosed()

	Return 0
EndFunc   ;==>_Main
#EndRegion _Main()
